local logging = nsg.logging
local type, date, open = type, os.date, io.open
local rename = os.rename

module"nsg.logging"

function logging.file(filename, datePattern, logPattern, maxFsize)
  
  if type(filename) ~= "string" then
    filename = "/var/log/nsgconfd.log"
  end
  --filename = string.format(filename, os.date(datePattern))
  local f = open(filename, "a")
  if not f then
    return nil, ("file `%s' could not be opened for writing"):format(filename)
  end
  f:setvbuf ("line")
  local fsize = 0
  local maxFsize = maxFsize or 1024 * 100
  
  return logging.new( function(self, level, message, newfsize)
      if newfsize then
        maxFsize = newfsize
        return true
      end
      local s = logging.prepareLogMsg(logPattern, date(datePattern), level, message)
      fsize = fsize + #s
      if fsize > maxFsize then
        f:close()
        rename(filename, filename..".prev")
        f = open(filename, "a")
        f:setvbuf ("line")
        fsize = 0
      end
      f:write(s)
      return true
    end
  )
end
