local string, type, tostring, pairs, table = string, type, tostring, pairs, table

module('nsg')

function  xmlEncode(s)
   s = tostring(s or '')
   if s:match("[%&%<%>%'%\"]") then
      return s:gsub("&","&amp;"):gsub("<","&lt;"):gsub(">","&gt;"):gsub("'","&apos;"):gsub('"',"&quot;")
      --return '\n<![CDATA[\n' .. s .. '\n]]>\n'
   else
      return s
   end
end

function endTag(s)
   s = (tostring(s)):match("^([a-zA-Z][a-zA-Z0-9%:_]*)")
   return s and '</'..s..'>' or ""
end

function startTag(s)
   return '<'..s..'>'
end
function shortTag(s)
   return '<'..s..'/>'
end

local function prompt(pr)
   if pr then
      return "\n"..string.rep(' ', pr)
   else
      return ""
   end
end

local function incPr(pr)
   if pr then pr = pr + 2 end
   return pr
end

local function decPr(pr)
   if pr then pr = pr - 2 end
   return pr
end

function xmlize(name, o, pr, saved)
   name = name or "root"
   if not (type(name)=="string" or type(name)=="number") then
      return ""
   end
   local forgen = pr and pairsByKeys or pairs
   local t = type(o)
   if t == "number" or  t == "string" then
      o = xmlEncode(o)
      return #o>0 and (startTag(name)..o..endTag(name)) or shortTag(name)
   elseif t == "table" then
      local result = ""
      saved = saved or {}
      if saved[o] ~= nil then
         return shortTag(name.."_ERR_RECURSION")
      else
         saved[o] = tostring(k)
      end

      if #o>0 then
         --this siblings values with the same name!
         for k, v in forgen(o, compareObject) do
            result = result..prompt(pr)..xmlize(name, v, pr, saved)
         end
      else
         pr = incPr(pr)
         result = startTag(name)
         for k, v in forgen(o, compareObject) do
            result = result ..prompt(pr)..xmlize(k, v, pr, saved)
         end
         pr = decPr(pr)
         result = result..prompt(pr)..endTag(name)
      end
      return result
   else
      return startTag(name)..xmlEncode(o)..endTag(name)
   end
end
function xmlInsertLast(xml, ins)
   if type(xml) == 'string' and  type(ins) == 'string' then
      local res = (xml:gsub("(</[^<>]*>)([%s%z%c]*)$", ins:gsub("[%%]","%%%%").."%1%2"))
      return (#res == #xml + #ins and res or nil), (#res ~= #xml + #ins and "Bad XML" or nil)
   else
      return nil, "Parameters must be the same type!"
   end
end