module(..., package.seeall)
local T1 = os.clock()
local conf = require'nsgconf'
local utf8 = require'utf8'
local nsg = require'nsg'

local nsgPageName = nsgPageName -- get from parent script
local urlDecode
local htmlEncode
local doCmd
local doCmdXML
local mainPage
local loginPage
local genOut
local genError
local genFast
local usec
local tag
local bodyPrint
local stdHead
local fstr
local calcValue
local initPostData
local initEnvData
local headPrint
local htmlDecode
local checkPasswd
local selectLanguage
local explodeToTable
local tokens
local readpopen
local fixCRLF
local splitString
local escapeForScript
local script
local hideCTRL
local text
local textXML
local alertScript
local alertScriptXML
local xmlHead
local parseCookie


readpopen = function (prog)
  local f = io.popen(prog)
  local s
  if f then
    s = f:read("*a")
    f:close()
  end
  return s
end

local version = readpopen("{ cat /version 2>/dev/null || date; } | sed  -r 's/[^[:alnum:]._-]+//g' | tr -d '\\n'") or tostring(math.random())

local old_checkPasswd = function(login, pass)
                 require"posix"
                 local f
                 f = io.open("/etc/shadow", "r")
                 if not f then
                    return false
                 end
                 local hash
                 hash = f:read("*a")
                 if not hash then
                    return false
                 end
                 f:close()
                 --print(hash)
                 hash = string.match(hash, "[^%W]*"..login..":([^:]*):")
                 --print(hash)
                 if not hash then
                    return false
                 elseif hash=="" then
                    return true
                 else
                    local res
                    local res2
                    res,res2 = pcall(posix.crypt,pass,hash)
                    if res and res2==hash then
                       return true
                    else
                       return false
                    end
                 end
                 return false
              end


checkPasswd = function(login, pass)
  local res = nsg.pamAuth('login', login, pass)
  if not res then
    return old_checkPasswd(login, pass)
  else
    return res
  end
end

stdHead = function (http, mode)
             --http:headPrint("HTTP/1.0 200 OK")
             http:headPrint("Status", "200")
--             http:headPrint("Content-Type", "text/"..(mode or "html"))
             http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")
             http:headPrint("Cache-Control", "post-check=0, pre-check=0")
          end

fstr = function (...)
          return table.concat({...})
       end

calcValue = function (valString, raw)
               if not raw then
                  valString = valString:match"^%s*(.-)%s*$" or ''
               end
               if valString == '' or valString == 'nil' then
                  valString = nil
               else
                  local res, value, v1 = pcall(loadstring('setfenv(1, {})return '..valString))
                  if not res or value == nil or v1 then
                     res, valString = pcall(loadstring('setfenv(1, {})return '..
                                                       string.format('%q', valString)))
                  else
                     valString = value
                  end
                  if not res then valString = nil end
               end
               return valString
            end

parseCookie = function (cookie)
                 res = {}
                 for s1,s2 in string.gmatch(';'..cookie..';', '%s*([^;=]+)%s*%=([^;]*)') do
                    res[urlDecode(s1)] = urlDecode(s2)
                 end
                 return res
              end

initPostData = function (http)
                  if nsgServer == "xavante" then
                     http.data = cgilua.POST
                  else
                     if( http.env.request_method == 'POST' and
                         -- string.match(http.env.content_type,'application\/x-www-form-urlencoded') and
                         tonumber(http.env.content_length) > 0 )
                     then
                        local x=0
                        -- !!!  Don`t read more then http.env.content_length
                        for line in io.lines() do
                           http.raw_post = http.raw_post .."\010".. line;
                           for s1,s2 in string.gmatch('&'..line..'&', '([^&=]*)%=([^&]*)') do
                              http.data[urlDecode(s1)] = urlDecode(s2)
                           end
                           x = x + string.len(line)+1
                           if x >  tonumber(http.env.content_length) then
                              break
                           end
                        end
                     end

                     -- override POST data through url string
                     local x1,x2,params = string.find(http.env.request_uri or '', '?(.*)$')
                     for s1,s2 in string.gmatch((params or "") ..'&', '([^&=]*)%=([^&=]*)') do
                        http.data[s1] = s2
                     end
                  end
               end

tokens = function (s, delim)
   local pos = 1
   return function()
             local f, l = string.find(s, '[^'..delim..']+', pos)
             if f then
                pos = l + 1
                return string.sub(s, f, l)
             else
                return nil
             end
          end
end

explodeToTable = function (path, delim)
   local pathTable = {}
   for s in tokens(path, delim) do
      table.insert(pathTable, s)
   end
   return pathTable
end

selectLanguage = function (http_lang)
   local langTokens = explodeToTable(http_lang or "ru", ",")
   local lang = {};
   local maxLang = "ru"
   local maxQ = 0
   local l,q
   for k,v in ipairs(langTokens) do

      l, q = string.match( string.gsub(v, "%s", "") , "([a-zA-Z][a-zA-Z])([;]*)([q=]*)([0-9.]*)")

      if((q == nil) or (q=="")) then
         q =  1000
      else
         q = string.match(q, ";q=([0-9.]*)" )
         if((q == nil) or (q=="")) then
            q =  1000
         else
            q = tonumber(q)
         end
      end
      l = l or "en"
      --print("//".. l .."~".. tostring(q))
      if(type(lang[l]) == "number") then
         lang[l] = ((tonumber(q) > lang[l]) and q) or lang[l]
      else
         lang[l] = tonumber(q)
      end

      if maxQ < lang[l] then
         maxQ = lang[l]
         maxLang = l
      end
   end
   return maxLang
end


initEnvData = function (http)
                 if (nsgServer == "xavante") then
                    http.env['lang'] = selectLanguage(cgilua.servervariable("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     cgilua.servervariable("AUTH_TYPE")
                    http.env['gateway_interface'] = cgilua.servervariable("GATEWAY_INTERFACE")
                    http.env['path'] =          cgilua.servervariable("PATH")
                    http.env['path_info'] =     cgilua.servervariable("PATH_INFO")
                    http.env['pwd'] =           cgilua.servervariable("PWD")
                    http.env['query_string'] =  cgilua.servervariable("QUERY_STRING")
                    http.env['remote_addr'] =   cgilua.servervariable("REMOTE_ADDR")
                    http.env['remote_port'] =   cgilua.servervariable("REMOTE_PORT")
                    http.env['remote_user'] =   cgilua.servervariable("REMOTE_USER")
                    http.env['request_method'] = cgilua.servervariable("REQUEST_METHOD")
                    http.env ['request_uri'] =   cgilua.servervariable("REQUEST_URI")
                    http.env['script_filename'] =cgilua.servervariable("SCRIPT_FILENAME")
                    http.env['script_name'] =   cgilua.servervariable("SCRIPT_NAME")
                    http.env['server_port'] =   cgilua.servervariable("SERVER_PORT")
                    http.env['server_name'] =   cgilua.servervariable("SERVER_NAME")
                    http.env['server_protocol'] = cgilua.servervariable("SERVER_PROTOCOL")
                    http.env['server_software'] = cgilua.servervariable("SERVER_SOFTWARE")
                    http.env['content_type'] =  cgilua.servervariable("CONTENT_TYPE")
                    http.env['content_length'] =cgilua.servervariable("CONTENT_LENGTH")
                    http.env['cookie'] =        parseCookie(cgilua.servervariable("HTTP_COOKIE") or "")
                 else
                    http.env['lang'] = selectLanguage(os.getenv("HTTP_ACCEPT_LANGUAGE"))
                    http.env['auth_type'] =     os.getenv("AUTH_TYPE")
                    http.env['gateway_interface'] = os.getenv("GATEWAY_INTERFACE")
                    http.env['path'] =          os.getenv("PATH")
                    http.env['path_info'] =     os.getenv("PATH_INFO")
                    http.env['pwd'] =           os.getenv("PWD")
                    http.env['query_string'] =  os.getenv("QUERY_STRING")
                    http.env['remote_addr'] =   os.getenv("REMOTE_ADDR")
                    http.env['remote_port'] =   os.getenv("REMOTE_PORT")
                    http.env['remote_user'] =   os.getenv("REMOTE_USER")
                    http.env['request_method'] = os.getenv("REQUEST_METHOD")
                    http.env ['request_uri'] =   os.getenv("REQUEST_URI")
                    http.env['script_filename'] = os.getenv("SCRIPT_FILENAME")
                    http.env['script_name'] =   os.getenv("SCRIPT_NAME")
                    http.env['server_port'] =   os.getenv("SERVER_PORT")
                    http.env['server_name'] =   os.getenv("SERVER_NAME")
                    http.env['server_protocol'] = os.getenv("SERVER_PROTOCOL")
                    http.env['server_software'] = os.getenv("SERVER_SOFTWARE")
                    http.env['content_type'] =  os.getenv("CONTENT_TYPE")
                    http.env['content_length'] = os.getenv("CONTENT_LENGTH")
                    http.env['cookie'] =        parseCookie(os.getenv("HTTP_COOKIE") or "")
                 end
              end

urlDecode = function(s)
               return (string.gsub (string.gsub (tostring(s or ""), "+", " "),
                                    "%%(%x%x)",
                                    function (str)
                                       return string.char (tonumber (str, 16))
                                    end )
                    )
            end

htmlEncode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s or ""), "&", "&amp;"),
                                                              "\"",
                                                              "&quot;"),
                                                 "<",
                                                 "&lt;"),
                                    ">",
                                    "&gt;")
             end


htmlDecode = function(s)
                return string.gsub( string.gsub (string.gsub (string.gsub (tostring(s), "&qt;", ">"),
                                                              "&quot;",
                                                              "\""),
                                                 "&lt;",
                                                 "<"),
                                    "&amp;",
                                    "&")
             end



headPrint = function(http, param, value)
               if param ~= nil then
                  http.head[param] = value
               end
            end


bodyPrint = function(http, text, ...)
               if text ~= nil then
                  http.body.text = http.body.text..tostring(text)
                  http:bodyPrint(...)
               end
            end


tag = function (shift, tag, param, inner, ret_inner)
         if(tag > "") then
            white=""
            end_white=""

            if(type(ret_inner) == 'nil') then
               ret_inner= "\n"
            else
               if(ret_inner ~= "" ) then
               end
            end

            --inner=table.concat(inner)
            while (shift > 0 ) do
               shift=shift - 1
               white = white.."  "
            end
            end_white=white

            if(ret_inner == "" ) then
               end_white=""
            end

            if(inner ~= "") then
               inner = ret_inner..inner
            else
               inner = ""
            end

            return white.."<"..tag.." "..param..">"
               ..inner..ret_inner..end_white.."</"..tag..">"
         else
            return inner
         end
      end

genOut = function(http)
            if #http.body.text==0 then http.body.text = "\0" end
            if nsgServer == "xavante" then
               cgilua.contentheader("text",http.data.mode or "html")
               cgilua.header("Cache-Control","no-store, no-cache, must-revalidate");
              -- cgilua.header("Cache-Control", "post-check=0, pre-check=0");
               for k,v in pairs(http.head) do
                  cgilua.header(k, v)
               end
               cgilua.put(http.body.text);
            else
               io.write("HTTP/1.0  "..tostring(http.head["Status"] or 200).." OK".."\013\010")
               http:headPrint("Cache-Control", "no-store, no-cache, must-revalidate")

               for k,v in pairs(http.head) do
                  if k ~= "Status" then
                     io.write(k,":",v,"\013\010");
                  end
               end
               io.write("\013\010");
               io.write(http.body.text)
            end
         end

genError = function(http, status, ...)
              http.head = {}
             -- headPrint(http, "HTTP/1.0 "..tostring(status).." OK")
              headPrint(http, "Status", tostring(status))

              http.body.text = ""
              http:bodyPrint("<html>")
              http:bodyPrint(...)
              http:bodyPrint("<pre>Env data:\010")
              for k,v in pairs(http.env) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>POST data:\010")
              for k,v in pairs(http.data) do
                 http:bodyPrint(k.."="..v.."\010")
              end
              http:bodyPrint("</pre>")
              http:bodyPrint("<pre>Raw post data:\010"..http.raw_post.."</pre>")
              http:bodyPrint("</html>")
              genOut(http)
           end

genFast = function(http, status, ...)
             http.head = {}
             --http.head.print("HTTP/1.0 "..tostring(status).." OK")
             headPrint(http, "Status", tostring(status))

             http.body.text = ""
             http.body.print(...)
             http.genOut()
          end

usec = function ()
          local f=io.popen ("cat /proc/uptime | grep -o '^[0-9]*[.][0-9]*'")
          if f then
             t=f:read("*n")
             f:close()
             return t
          else
             return 0
          end
       end

loginPage = function (http, status)
               http:headPrint("Set-Cookie", "sesnum=0")
               local devName = function()
                                  local dev = {}
                                  dev[#dev + 1] = htmlEncode(readpopen("cat /proc/nsg/env | grep nsg_device | grep -oe '[^=]*$'"))
                                  dev[#dev + 1] = htmlEncode(readpopen("hostname"))
                                  return table.concat(dev, "<br/>")
                               end
               local err
               local ret = ""
               http.data.mode = "html"
               http:bodyPrint(
                  [[<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" >
                           <html>
                           <head>
                           <title>NSG Web Configuration Manager</title>
                           <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
                           <link rel="stylesheet" type="text/css" href="/style.css?]]..version..[[">
                           <link rel="icon" type="image/x-icon" href="/nsg.ico">
                           <link rel="shortcut icon" type="image/x-icon" href="/nsg.ico">
                           </head>
                           <body class="login">
                     ]]..
                     --(http.env['remote_addr'] or "")..
                     (status and "Message:<br/><pre>"..status.."</pre>" or "")..
                     [[
                                 <div class="login">
                                 <center>
                           <form id="loginform" class="login" onsubmit=" var loginform=document.getElementById('loginform'); if(loginform) loginform.onsubmit = function(){return false; };" method="post" enctype="application/x-www-form-urlencoded">
                                 <table class="login">
                                 <tbody>

                                 <tr height="40%">
                                 <td class="bottomcenter">
                                 <img src="/nsg_logo.png"><br/>]]..
                      devName()..
                      [[</td>
                                 </tr>
                                 <tr height="35"><td class="lcenter">Name:<input type="text" name="login" /><font color="#6699cc" >:emaN</font></td></tr>
                                 <tr height="35"><td class="lcenter">Password:<input type="password" name="pass" /><font color="#6699cc" >:drowssaP</font></td></tr>
                                 <tr><td class="topcenter"><input type="submit" name="submit" value="Login" /> 
                                 <input type="hidden" name="command" value="start" />
                                 <input type="hidden" name="timeout" value="60" />
                              </td></tr>
                                 </tbody>
                                 </table>
                                 </form>
                                 </center>
                                 </div>
                                 </body>
                                 </html>
                           ]])
            end
fixCRLF =
   function (s)
      return s~=nil and  tostring(s):gsub("\n( *)(\t?)", function(s,t)
                                                            return'\n'..(t~=''and('\t'):rep(#s+1)or'')
                                                         end or ""
                                       )
   end

splitString =
   function (s)
      s = s or ""
      local out = {}
      local i = 70
      local i2 = 0
      local len = utf8.len(s) or 0
      while i2<len do
         out[#out+1] = utf8.sub(s,i2 + 1, i2 + i)
         i2 = i2 + i
      end
      return out
   end

escapeForScript =
   function (s)
      s = splitString(s)
      for k,v in ipairs(s) do
         s[k] = '"'..((((((tostring(v or "" )):gsub("\\","\\\\")):gsub("\r","\\r")):gsub("\n","\\n")):gsub('"','\\"')):gsub("'","\\'") or "")..'"'
      end
      s[#s+1] = '""'
      return table.concat(s,"+")
   end
script =
   function (s)
      return "<span class=\"hiddenscript\"><textarea class=\"hiddentext\">"..htmlEncode(s or "").."</textarea></span>"
   end

scriptXML =
   function (s)
      return nsg.xmlize("script", s or "")
   end

hideCTRL =
   function (s)
      return ("%q"):format(s):gsub("\\\n","\\n");
   end

text =
   function (s)
      return "<span class=\"hiddentext\"><textarea class=\"hiddentext\">"..htmlEncode(hideCTRL(s or "")).."</textarea></span>"
   end

textXML =
   function (s)
      return {text = hideCTRL(s or "")}
   end

defXML =
   function (s)
      return '<DEF>'..s..'</DEF>'
   end

alertScriptXML =
   function (s)
      local len = utf8.len(s or "")
      local max=2500
      return s~=nil and scriptXML('alert('..escapeForScript(fixCRLF(len>max and s:sub(1,utf8.find(s,"%s",max/2) or max/2)..'...\n---- truncated ----\n...'..s:sub(utf8.find(s,"%s",-max/2) or -max/2) or s))..');') or ""
   end

alert =
   function (s, h)
      local len = utf8.len(s or "")
      local max=2500
      return s~=nil and ('alert(xmlTransform('..escapeForScript(fixCRLF(xmlHead(nsg.xmlize("POPUP",{head = h, body = s}))))..'));') or ""
   end

alertScript =
   function (s)
      local len = utf8.len(s or "")
      local max=2500
      return s~=nil and script('alert('..escapeForScript(fixCRLF(len>max and s:sub(1,utf8.find(s,"%s",max/2) or max/2)..'...\n---- truncated ----\n...'..s:sub(utf8.find(s,"%s",-max/2) or -max/2) or s))..');') or ""
   end

doCmd =
   function(cmd, htmlEnv)
      if htmlEnv.data.mode == 'xml' then
         return doCmdXML(cmd, htmlEnv)
      end
      local ses
      local err
      local msg
      local ret = ""
      local noSes = {
         getHTML = true,
--         loadDictionary = true
      }

      if not noSes[cmd] then
         ses, err = conf.open({
                                 sesnum = (htmlEnv.data.sesnum or tonumber(htmlEnv.env.cookie.sesnum) or 0),
                                 user = htmlEnv.data.login,
                                 mode = "html",
                                 maxRights = (htmlEnv.data.maxRights or nil),
                              })
         if ses then
            local webMode = ses:getWebMode()
            if webMode == 'xml' then
               htmlEnv.data.mode= 'xml'
               htmlEnv.data.sesnum = ses.sesnum
               htmlEnv.data.sessionMessage = err
               return doCmdXML(cmd, htmlEnv)
            end
         else
            if cmd == "tty" then
               return text("_C_L_O_S_E_D_")
            elseif cmd == "start" then
               return loginPage(htmlEnv,"Can't open nsgconf session("..(err or "")..")")
            else
               local _H = "webStartNewSession"
               local _H = "CantOpenSession"
               return  script('if (confirm(getHelp("CantOpenSession")+"("+'..escapeForScript(err or "")..'+ "). "+getHelp("webStartNewSession"))) window.location.replace(window.location.pathname);')
            end
         end
         htmlEnv.data.sesnum = ses.sesnum
         ses.timeout = (htmlEnv.data.timeout  or 20) -1
      end
      local cmdA
      cmdA = {
         login =
            function()
               msg = loginPage(htmlEnv)
            end,
         logOut =
            function()
               ret = ses:isConfigChanged()
               if (ret and not htmlEnv.data.force) then
                  local _H = "webCfgNotSavedContinue"
                  msg = script([[
                                     if (confirm(getHelp("webCfgNotSavedContinue"))) {
                                        logOut(true);
                                     };
                               ]])
               else
                  pcall(ses.closeSession, ses);
                  msg = script("window.location.replace(window.location.pathname);")
               end
            end,
         start =
            function()
               local directHTML = ses:getHTMLModule()
               if directHTML then
                  htmlEnv.data.module = directHTML
                  htmlEnv.data.path = "{}"
                  htmlEnv.data.command = "getHTML"
                  htmlEnv.data.subcmd = "start"
                  pcall(ses.closecon, ses)
                  ses = nil
                  cmdA.getHTML()
               else
                  htmlEnv.data.pagename = nsgPageName
                  htmlEnv.data.locale = htmlEnv.data.locale or ses:setLocale() or htmlEnv.env.lang or "en"
                  ses:setLocale(htmlEnv.data.locale)
                  htmlEnv.data.sessionMessage = (htmlEnv.data.sessionMessage or err or "")
                  ret, err = ses:getConf( false, {htmlEnv={data=htmlEnv.data}})
                  if ret then
                     htmlEnv:headPrint("Set-Cookie", "sesnum="..ses.sesnum)
                  end
                  msg =  ret and  ret or alertScript(err)
               end
            end,
         edit =
            function()
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), false)
               msg =  ret and ret or alertScript(err)
            end,
         getConf =
            function()
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), {htmlEnv={data=htmlEnv.data}})
               msg =  ret and  ret or alertScript(err)
            end,
         tty =
            function()
               ret, msg = ses:tty(calcValue(htmlEnv.data.path) or {},  htmlEnv.data.value and htmlEnv.data.value or htmlEnv.data.value)
               msg = text((ret) or
                       (type(ret) == 'boolean' and (not ret) and (msg~="") and  msg) or
                    ((not ret or  msg=="") and "_C_L_O_S_E_D_") or msg)
            end,
         setValue =
            function()
               local rerr, rmsg
               if htmlEnv.data.value == nil then
                  rerr, rmsg = doCmd("removeKey", htmlEnv)
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not rerr then
                     msg = (msg or "")..(rmsg and alertScript(rmsg) or "")
                  end
               else
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not err then
                     msg = (msg or "")..(ret and alertScript(ret) or "")
                  end
               end
            end,
         paste =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlDecode(htmlEnv.data.value)) or "", nil)
               msg = (not err and alertScript(msg or "Error") or "")..script("loadDir(window.execScriptsParam, true);")
            end,
         validate =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlEnv.data.value) or "", true)
               msg = alertScript(msg or "OK")
            end,
         newKey =
            function()
               err, msg = ses:newKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or  alertScript(msg)
            end,
         insertKey =
            function()
               err, msg = ses:insertKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or  alertScript(msg)
            end,
         saveConf =
            function()
               err, msg = ses:saveConf(calcValue(htmlEnv.data.path) or {})
               msg = err and  alertScript(err) or alertScript(msg or "Not saved!")
            end,
         applyConf =
            function()
               err, msg = ses:applyConf(calcValue(htmlEnv.data.path) or {})
               msg =  msg and alertScript(msg) or alertScript( err and "Ok" or "Fail")
            end,
         getManual =
            function()
               msg = ses:getManual(calcValue(htmlEnv.data.path) or {}, "No manual for this entry.")
               msg =  msg and alertScript(msg)
            end,
         setLocale =
            function()
               msg = ses:setLocale(htmlEnv.data.locale)
               msg =  msg and alertScript(msg) or ""
            end,
         getUsage =
            function()
               msg = ses:getUsage(htmlEnv.data.locale)
               msg =  msg and script("window.execScriptsParam.innerHTML="..
                                     escapeForScript(msg).." + "..
                                  escapeForScript('<img alt="refresh" tabindex=0 class="brefresh" src="/nil.png">')) or ""
            end,
         removeKey =
            function()
               err, msg = ses:removeKey(calcValue(htmlEnv.data.path) or {})
               msg = err and msg or alertScript(msg)
            end,
         executeTask =
            function()
               err, msg, ret = ses:executeTask(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and text(msg)  or  msg and alertScript(msg)
            end,
         getHTML =
            function()
               ses, err = conf.open({
                                       sesnum = 0,
                                       user = htmlEnv.data.login,
                                       mode = "xml",
                                       maxRights = (htmlEnv.data.maxRights or nil),
                                    })
               if ses then
                  htmlEnv.data.pagename = nsgPageName
                  htmlEnv.data.locale = htmlEnv.data.locale or ses:setLocale() or htmlEnv.env.lang or "en"
                  ses:setLocale(htmlEnv.data.locale)
                  if ses:getHTMLModule(calcValue(htmlEnv.data.path)) == htmlEnv.data.module then
                     err, msg =  pcall(require, htmlEnv.data.module)
                     if err then
                        err, ret, msg = pcall(msg.getHTML, htmlEnv)
                     end
                  else
                     err, msg = nil, "Error: Web module incorrect:"..tostring(module).."<>"..tostring(htmlEnv.data.module)
                  end
                  pcall(ses.closeSession, ses)
               else
                  err, msg  = nil, err
               end
               msg = err and msg or (msg or "Error")..tostring(ret)
            end,
         error =
            function()
               msg = alertScript("Error command:"..cmd)
            end,
      }

      (cmdA[cmd or "error"] or cmdA.error)()
      if ses then
         pcall(ses.closecon, ses)
      end
      return tostring(msg)
   end


-- +++++ XML XML XML
xmlHead = function(xmlText)
                            return '<?xml version="1.0" encoding="UTF-8" ?>\n'..xmlText
                    end

doCmdXML =
   function(cmd, htmlEnv)
      if htmlEnv.data.mode == 'http' then
         return doCmd(cmd, htmlEnv)
      end
      local ses
      local err
      local msg
      local ret = ""
      local noSes = {
         getHTML = true,
      }

      if not noSes[cmd] then
         ses, err = conf.open({
                                 sesnum = (htmlEnv.data.sesnum or tonumber(htmlEnv.env.cookie.sesnum) or 0),
                                 user = htmlEnv.data.login,
                                 mode = "xml",
                                 maxRights = (htmlEnv.data.maxRights or nil),
                              })
         if not ses then
            if cmd == "tty" then
               return xmlHead(nsg.xmlize("NSG", { text = "_C_L_O_S_E_D_"}))
            elseif cmd == "start" then
               return loginPage(htmlEnv,"Can't open nsgconf session("..(err or htmlEnv.data.sessionMessage or "")..")")
            else
               local _H = "webStartNewSession"
               local _H = "CantOpenSession"
               return  xmlHead(nsg.xmlize("NSG",{ script = 'if (confirm(getHelp("CantOpenSession")+"("+'..escapeForScript(err or htmlEnv.data.sessionMessage or "")..'+ "). "+getHelp("webStartNewSession"))) window.location.replace(window.location.pathname);'}))
            end
         end
         htmlEnv.data.sesnum = ses.sesnum
         ses.timeout = (htmlEnv.data.timeout  or 20) -1
      end
      stdHead(htmlEnv,"xml")
      local cmdA
      cmdA = {
     --[[    login =
            function()
               msg = loginPage(htmlEnv)
            end,
            --]]
         logOut =
            function()
               ret = ses:isConfigChanged()
               if (ret and not htmlEnv.data.force) then
                  local _H = "webCfgNotSavedContinue"
                  msg = xmlHead(nsg.xmlize("NSG", { script = 'if (confirm(getHelp("webCfgNotSavedContinue"))) { logOut(true); };' }))
               else
                  pcall(ses.closeSession, ses);
                  msg = xmlHead(nsg.xmlize("NSG", { script = 'window.location.replace(window.location.pathname);' }))
               end
            end,
         start =
            function()
               local directHTML = ses:getHTMLModule()
               if directHTML then
                  htmlEnv.data.module = directHTML
                  htmlEnv.data.path="{}"
                  htmlEnv.data.command = "getHTML"
                  htmlEnv.data.subcmd = "start"
                  pcall(ses.closecon, ses)
                  ses = nil
                  cmdA.getHTML()
               else
                  htmlEnv.data.pagename = nsgPageName
                  htmlEnv.data.locale = htmlEnv.data.locale or ses:setLocale() or htmlEnv.env.lang or "en"
                  ses:setLocale(htmlEnv.data.locale)
                  htmlEnv.data.mode = ses:getWebMode() or "xml"
                  ses:setMode(htmlEnv.data.mode)
                  htmlEnv.data.sessionMessage = (htmlEnv.data.sessionMessage or err or "")
                  ret, err = ses:getConf( false, {htmlEnv={data=htmlEnv.data}})
                  if ret then
                     htmlEnv:headPrint("Set-Cookie", "sesnum="..ses.sesnum)
                  end
                  -- ret in XML !!!
                  msg =  ret and  xmlHead("")..'<?xml-stylesheet type="text/xsl" href="style.xsl?'..version..'" ?>\n'..ret or xmlHead("")..'<?xml-stylesheet type="text/xsl" href="style.xsl?'..version..'" ?>\n'..nsg.xmlize("LOGINPAGE",{error = err})
               end
           end,
         edit =
            function()
               ses:setMode("text")
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), false)
               -- ret in TEXT !!!
               msg =  ret and  xmlHead(nsg.xmlize("EDIT", {text = ret})) or xmlHead(nsg.xmlize("NSG",{script = alert(err)}))
               ses:setMode("xml")
            end,
         getConf =
            function()
               ret, err = ses:getConf( (calcValue(htmlEnv.data.path) or {}), {htmlEnv={data=htmlEnv.data}})
               -- ret in XML !!!
               msg =  ret and xmlHead(ret) or xmlHead(nsg.xmlize("NSG",{script = alert(err)}))
            end,
         tty =
            function()
               ret, msg = ses:tty(calcValue(htmlEnv.data.path) or {},  htmlEnv.data.value and htmlEnv.data.value or htmlEnv.data.value)
               -- ret in TEXT !!!
               msg =xmlHead(nsg.xmlize("NSG",textXML((ret) or
                       (type(ret) == 'boolean' and (not ret) and (msg~="") and  msg) or
                    ((not ret or  msg=="") and "_C_L_O_S_E_D_") or msg)))
            end,
         setValue =
            function()
               local rerr, rmsg
               if htmlEnv.data.value == nil then
                  rerr, rmsg = doCmd("removeKey", htmlEnv)
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not rerr then
                    -- msg = (msg or "")..(rmsg and xmlHead(nsg.xmlize("NSG",{script = alert(rmsg)})) or "")
                     msg = nsg.xmlInsertLast(xmlHead(msg or ""), rmsg and nsg.xmlize("script", alert(rmsg)) or "")
                  end
               else
                  err, ret, msg = ses:setValue(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
                  if not err then
                     msg = nsg.xmlInsertLast(xmlHead(msg or ""), ret and nsg.xmlize("script", alert(ret)) or "")
                  end
               end
            end,
         paste =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlDecode(htmlEnv.data.value)) or "", nil)
               local scr = {}
               scr[#scr + 1] = not err and  alert(msg or "Error")
               scr[#scr + 1] = 'loadDir(window.execScriptsParam, true);'
               msg = xmlHead(nsg.xmlize("NSG",{script = scr}))
            end,
         validate =
            function()
               err, msg = ses:paste(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and (htmlEnv.data.value) or "", true)
               msg = xmlHead(nsg.xmlize("NSG",{script = alert(msg or "OK")}))
            end,
         newKey =
            function()
               err, msg = ses:newKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or msg and xmlHead(nsg.xmlize("NSG",{script = alert(msg)}))
            end,
         insertKey =
            function()
               err, msg = ses:insertKey(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and msg or  msg and  xmlHead(nsg.xmlize("NSG",{script = alert(msg)}))
            end,
         saveConf =
            function()
               err, msg = ses:saveConf(calcValue(htmlEnv.data.path) or {})
               msg = err and  xmlHead(nsg.xmlize("NSG",{script = alert(err)})) or xmlHead(nsg.xmlize("NSG",{script = alert(msg or "Not saved!")}))
            end,
         applyConf =
            function()
               err, msg = ses:applyConf(calcValue(htmlEnv.data.path) or {})
               msg =  msg and xmlHead(nsg.xmlize("NSG",{script = alert(msg)})) or xmlHead(nsg.xmlize("NSG",{script = alert(err and "Ok" or "Fail")}))
            end,
         getManual =
            function()
               msg = ses:getManual(calcValue(htmlEnv.data.path) or {}, "No manual for this entry.")
               local path = calcValue(htmlEnv.data.path)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{script = alert(msg, table.concat(#path>0 and path  or {"NSG"},"."))})) or ""
            end,
         setLocale =
            function()
               msg = ses:setLocale(htmlEnv.data.locale)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{script = alert(msg)})) or ""
            end,
         getUsage =
            function()
               msg = ses:getUsage(htmlEnv.data.locale)
               msg =  msg and xmlHead(nsg.xmlize("NSG",{script = "window.execScriptsParam.innerHTML="..
                                     escapeForScript(msg).." + "..
                                  escapeForScript('<img alt="refresh" tabindex=0 class="brefresh" src="/nil.png">')}))
            end,
         removeKey =
            function()
               err, msg = ses:removeKey(calcValue(htmlEnv.data.path) or {})
               msg = err and msg or xmlHead(nsg.xmlize("NSG",{script = alert(msg)})) or ""
            end,
         executeTask =
            function()
               err, msg, ret = ses:executeTask(calcValue(htmlEnv.data.path) or {}, htmlEnv.data.value and calcValue(htmlEnv.data.value))
               msg = err and xmlHead(nsg.xmlize("NSG",textXML(msg)))  or  msg and xmlHead(nsg.xmlize("NSG",{script = alert(msg)}))
            end,
         getHTML =
            function()
               ses, err = conf.open({
                                       sesnum = 0,
                                       user = htmlEnv.data.login,
                                       mode = "xml",
                                       maxRights = (htmlEnv.data.maxRights or nil),
                                    })
               if ses then
                  htmlEnv.data.pagename = nsgPageName
                  htmlEnv.data.locale = htmlEnv.data.locale or ses:setLocale() or htmlEnv.env.lang or "en"
                  ses:setLocale(htmlEnv.data.locale)
                  if ses:getHTMLModule(calcValue(htmlEnv.data.path)) == htmlEnv.data.module then
                     err, msg =  pcall(require, htmlEnv.data.module)
                     if err then
                        err, ret, msg = pcall(msg.getHTML, htmlEnv)
                     end
                  else
                     err, msg = nil, "Error: Web module incorrect:"..tostring(module).."<>"..tostring(htmlEnv.data.module)
                  end
                  pcall(ses.closeSession, ses)
               else
                  err, msg  = nil, err
               end
               msg = err and msg or (msg or "Error")..tostring(ret)
            end,
         error =
            function()
               msg = alertScript("Error command:"..cmd)
            end,
      }

      (cmdA[cmd or "error"] or cmdA.error)()
      if ses then
         pcall(ses.closecon, ses)
      end
      return msg
   end


-- ----- XML XML  XML



function main()
   local http = {
      ['env']  = {},

      ['head'] = {
      },

      ['body'] = {
         ['text'] = ""
      },

      ['data'] = {},

      ['raw_post'] = '',
      headPrint = headPrint,
      bodyPrint = bodyPrint
   }

   initEnvData(http)
   initPostData(http)
--   stdHead(http)

   --   genError(http, KUU);

   if (http.data['command'] and http.data["login"] and http.data["pass"]) then
      if checkPasswd(http.data["login"], http.data["pass"]) then
         http:bodyPrint(doCmd(http.data['command'], http))
      elseif (http.data["command"]~="start") then
         local _H = 'AuthorizationFailedEnterPasswordForUser'
         local js = [[
               var res=window.prompt(getHelp("]].._H..[[")+LOGIN);
               if (res != null) {
                  PASS = res;
                  AUTH="mode=]]..(http.data.mode or "html")..[[&login=" + encodeURIComponent(LOGIN) + "&pass=" + encodeURIComponent(PASS) + "&sesnum=" + SID + "& ";
                  return "retry";
               }
            else {
                  window.location.replace(window.location.pathname);
               }
         ]]
         if http.data.mode == "xml" then
            http:bodyPrint(xmlHead(nsg.xmlize("NSG", { script = js })))
         else
            http:bodyPrint(script(js))
         end
      else
         loginPage(http, "Incorrect password or username!")
      end
   elseif (http.data["command"]=="start" and http.data["login"] and http.data["pass"]) then
      loginPage(http, "Incorrect password or username!")
   else --default
      loginPage(http)
   end
   genOut(http)
end

--main()

--io.write(" "..(os.clock()-T1).." " )
